Botan 1.10.17

Public Types | Public Member Functions | List of all members
Botan::AES_192_NI Class Reference

`#include <aes_ni.h>`

Inheritance diagram for Botan::AES_192_NI:

## Public Types
enum |

## Public Member Functions
| AES_192_NI ()
size_t | block_size () const
void | clear ()
BlockCipher * | clone () const
void | decrypt (const byte in[], byte out[]) const
void | decrypt (byte block[]) const
void | decrypt_n (const byte in[], byte out[], size_t blocks) const
void | encrypt (const byte in[], byte out[]) const
void | encrypt (byte block[]) const
void | encrypt_n (const byte in[], byte out[], size_t blocks) const
Key_Length_Specification | key_spec () const
size_t | maximum_keylength () const
size_t | minimum_keylength () const
std::string | name () const
size_t | parallel_bytes () const
size_t | parallelism () const
void | set_key (const SymmetricKey &key)
void | set_key (const byte key[], size_t length)
bool | valid_keylength (size_t length) const

## Detailed Description

AES-192 using AES-NI

Definition at line 40 of file aes_ni.h.

## Member Enumeration Documentation

## ◆ anonymous enum

anonymous enum
| inherited

Definition at line 107 of file block_cipher.h.

107 { BLOCK_SIZE = BS };
Botan::Block_Cipher_Fixed_Params< 16, 24 >::BLOCK_SIZE
Definition: block_cipher.h:107

## Constructor & Destructor Documentation

## ◆ AES_192_NI()

Botan::AES_192_NI::AES_192_NI | ( |  | ) |
| inline

Definition at line 52 of file aes_ni.h.

52 : EK(52), DK(52) { }

## Member Function Documentation

## ◆ block_size()

size_t Botan::Block_Cipher_Fixed_Params< BS, KMIN, 0 , 1 >::block_size | ( |  | ) | const
| inline virtual inherited

Returns
  block size of this algorithm

Implements Botan::BlockCipher.

Definition at line 108 of file block_cipher.h.

108 { return BS; }

## ◆ clear()

void Botan::AES_192_NI::clear | ( |  | ) |
| virtual

Zeroize internal state

Implements Botan::Algorithm.

Definition at line 523 of file aes_ni.cpp.

References Botan::zeroise().

524 {
525 zeroise(EK);
526 zeroise(DK);
527 }
Botan::zeroise
void zeroise(MemoryRegion< T > &vec)
Definition: secmem.h:428

## ◆ clone()

BlockCipher* Botan::AES_192_NI::clone | ( |  | ) | const
| inline virtual

Get a new object representing the same algorithm as *this

Implements Botan::BlockCipher.

Definition at line 50 of file aes_ni.h.

50 { return new AES_192_NI; }
Botan::AES_192_NI::AES_192_NI
AES_192_NI()
Definition: aes_ni.h:52

## ◆ decrypt() [1/2]

void Botan::BlockCipher::decrypt | ( | const byte | in[],
|  | byte | out[]
| ) |  | const
| inline inherited

Decrypt a block.

Parameters

  in | The ciphertext block to be decypted as a byte array. Must be of length block_size().
  out | The byte array designated to hold the decrypted block. Must be of length block_size().

Definition at line 57 of file block_cipher.h.

Referenced by Botan::DESX::decrypt_n().

58 { decrypt_n(in, out, 1); }
Botan::BlockCipher::decrypt_n
virtual void decrypt_n(const byte in[], byte out[], size_t blocks) const =0

## ◆ decrypt() [2/2]

void Botan::BlockCipher::decrypt | ( | byte | block[] | ) | const
| inline inherited

Decrypt a block.

Parameters

  block | the ciphertext block to be decrypted Must be of length block_size(). Will hold the result when the function has finished.

Definition at line 74 of file block_cipher.h.

74 { decrypt_n(block, block, 1); }
Botan::BlockCipher::decrypt_n
virtual void decrypt_n(const byte in[], byte out[], size_t blocks) const =0

## ◆ decrypt_n()

void Botan::AES_192_NI::decrypt_n | ( | const byte | in[],
|  | byte | out[],
|  | size_t | blocks
| ) |  | const
| virtual

Decrypt one or more blocks

Parameters

  in | the input buffer (multiple of block_size())
  out | the output buffer (same size as in)
  blocks | the number of blocks to process

Implements Botan::BlockCipher.

Definition at line 398 of file aes_ni.cpp.

References AES_DEC_4_LAST_ROUNDS, and AES_DEC_4_ROUNDS.

399 {
400 const __m128i* in_mm = (const __m128i*)in;
401 __m128i* out_mm = (__m128i*)out;
402
403 const __m128i* key_mm = (const __m128i*)&DK[0];
404
405 __m128i K0 = _mm_loadu_si128(key_mm);
406 __m128i K1 = _mm_loadu_si128(key_mm + 1);
407 __m128i K2 = _mm_loadu_si128(key_mm + 2);
408 __m128i K3 = _mm_loadu_si128(key_mm + 3);
409 __m128i K4 = _mm_loadu_si128(key_mm + 4);
410 __m128i K5 = _mm_loadu_si128(key_mm + 5);
411 __m128i K6 = _mm_loadu_si128(key_mm + 6);
412 __m128i K7 = _mm_loadu_si128(key_mm + 7);
413 __m128i K8 = _mm_loadu_si128(key_mm + 8);
414 __m128i K9 = _mm_loadu_si128(key_mm + 9);
415 __m128i K10 = _mm_loadu_si128(key_mm + 10);
416 __m128i K11 = _mm_loadu_si128(key_mm + 11);
417 __m128i K12 = _mm_loadu_si128(key_mm + 12);
418
419 while(blocks >= 4)
420 {
421 __m128i B0 = _mm_loadu_si128(in_mm + 0);
422 __m128i B1 = _mm_loadu_si128(in_mm + 1);
423 __m128i B2 = _mm_loadu_si128(in_mm + 2);
424 __m128i B3 = _mm_loadu_si128(in_mm + 3);
425
426 B0 = _mm_xor_si128(B0, K0);
427 B1 = _mm_xor_si128(B1, K0);
428 B2 = _mm_xor_si128(B2, K0);
429 B3 = _mm_xor_si128(B3, K0);
430
431 AES_DEC_4_ROUNDS(K1);
432 AES_DEC_4_ROUNDS(K2);
433 AES_DEC_4_ROUNDS(K3);
434 AES_DEC_4_ROUNDS(K4);
435 AES_DEC_4_ROUNDS(K5);
436 AES_DEC_4_ROUNDS(K6);
437 AES_DEC_4_ROUNDS(K7);
438 AES_DEC_4_ROUNDS(K8);
439 AES_DEC_4_ROUNDS(K9);
440 AES_DEC_4_ROUNDS(K10);
441 AES_DEC_4_ROUNDS(K11);
442 AES_DEC_4_LAST_ROUNDS(K12);
443
444 _mm_storeu_si128(out_mm + 0, B0);
445 _mm_storeu_si128(out_mm + 1, B1);
446 _mm_storeu_si128(out_mm + 2, B2);
447 _mm_storeu_si128(out_mm + 3, B3);
448
449 blocks -= 4;
450 in_mm += 4;
451 out_mm += 4;
452 }
453
454 for(size_t i = 0; i != blocks; ++i)
455 {
456 __m128i B = _mm_loadu_si128(in_mm + i);
457
458 B = _mm_xor_si128(B, K0);
459
460 B = _mm_aesdec_si128(B, K1);
461 B = _mm_aesdec_si128(B, K2);
462 B = _mm_aesdec_si128(B, K3);
463 B = _mm_aesdec_si128(B, K4);
464 B = _mm_aesdec_si128(B, K5);
465 B = _mm_aesdec_si128(B, K6);
466 B = _mm_aesdec_si128(B, K7);
467 B = _mm_aesdec_si128(B, K8);
468 B = _mm_aesdec_si128(B, K9);
469 B = _mm_aesdec_si128(B, K10);
470 B = _mm_aesdec_si128(B, K11);
471 B = _mm_aesdeclast_si128(B, K12);
472
473 _mm_storeu_si128(out_mm + i, B);
474 }
475 }
AES_DEC_4_LAST_ROUNDS
#define AES_DEC_4_LAST_ROUNDS(K)
Definition: aes_ni.cpp:94
AES_DEC_4_ROUNDS
#define AES_DEC_4_ROUNDS(K)
Definition: aes_ni.cpp:85

## ◆ encrypt() [1/2]

void Botan::BlockCipher::encrypt | ( | const byte | in[],
|  | byte | out[]
| ) |  | const
| inline inherited

Encrypt a block.

Parameters

  in | The plaintext block to be encrypted as a byte array. Must be of length block_size().
  out | The byte array designated to hold the encrypted block. Must be of length block_size().

Definition at line 47 of file block_cipher.h.

Referenced by Botan::aont_unpackage(), Botan::OFB::cipher(), Botan::DESX::encrypt_n(), Botan::OFB::set_iv(), Botan::CFB_Encryption::set_iv(), Botan::XTS_Encryption::set_iv(), Botan::CFB_Decryption::set_iv(), and Botan::XTS_Decryption::set_iv().

48 { encrypt_n(in, out, 1); }
Botan::BlockCipher::encrypt_n
virtual void encrypt_n(const byte in[], byte out[], size_t blocks) const =0

## ◆ encrypt() [2/2]

void Botan::BlockCipher::encrypt | ( | byte | block[] | ) | const
| inline inherited

Encrypt a block.

Parameters

  block | the plaintext block to be encrypted Must be of length block_size(). Will hold the result when the function has finished.

Definition at line 66 of file block_cipher.h.

66 { encrypt_n(block, block, 1); }
Botan::BlockCipher::encrypt_n
virtual void encrypt_n(const byte in[], byte out[], size_t blocks) const =0

## ◆ encrypt_n()

void Botan::AES_192_NI::encrypt_n | ( | const byte | in[],
|  | byte | out[],
|  | size_t | blocks
| ) |  | const
| virtual

Encrypt one or more blocks

Parameters

  in | the input buffer (multiple of block_size())
  out | the output buffer (same size as in)
  blocks | the number of blocks to process

Implements Botan::BlockCipher.

Definition at line 316 of file aes_ni.cpp.

References AES_ENC_4_LAST_ROUNDS, and AES_ENC_4_ROUNDS.

317 {
318 const __m128i* in_mm = (const __m128i*)in;
319 __m128i* out_mm = (__m128i*)out;
320
321 const __m128i* key_mm = (const __m128i*)&EK[0];
322
323 __m128i K0 = _mm_loadu_si128(key_mm);
324 __m128i K1 = _mm_loadu_si128(key_mm + 1);
325 __m128i K2 = _mm_loadu_si128(key_mm + 2);
326 __m128i K3 = _mm_loadu_si128(key_mm + 3);
327 __m128i K4 = _mm_loadu_si128(key_mm + 4);
328 __m128i K5 = _mm_loadu_si128(key_mm + 5);
329 __m128i K6 = _mm_loadu_si128(key_mm + 6);
330 __m128i K7 = _mm_loadu_si128(key_mm + 7);
331 __m128i K8 = _mm_loadu_si128(key_mm + 8);
332 __m128i K9 = _mm_loadu_si128(key_mm + 9);
333 __m128i K10 = _mm_loadu_si128(key_mm + 10);
334 __m128i K11 = _mm_loadu_si128(key_mm + 11);
335 __m128i K12 = _mm_loadu_si128(key_mm + 12);
336
337 while(blocks >= 4)
338 {
339 __m128i B0 = _mm_loadu_si128(in_mm + 0);
340 __m128i B1 = _mm_loadu_si128(in_mm + 1);
341 __m128i B2 = _mm_loadu_si128(in_mm + 2);
342 __m128i B3 = _mm_loadu_si128(in_mm + 3);
343
344 B0 = _mm_xor_si128(B0, K0);
345 B1 = _mm_xor_si128(B1, K0);
346 B2 = _mm_xor_si128(B2, K0);
347 B3 = _mm_xor_si128(B3, K0);
348
349 AES_ENC_4_ROUNDS(K1);
350 AES_ENC_4_ROUNDS(K2);
351 AES_ENC_4_ROUNDS(K3);
352 AES_ENC_4_ROUNDS(K4);
353 AES_ENC_4_ROUNDS(K5);
354 AES_ENC_4_ROUNDS(K6);
355 AES_ENC_4_ROUNDS(K7);
356 AES_ENC_4_ROUNDS(K8);
357 AES_ENC_4_ROUNDS(K9);
358 AES_ENC_4_ROUNDS(K10);
359 AES_ENC_4_ROUNDS(K11);
360 AES_ENC_4_LAST_ROUNDS(K12);
361
362 _mm_storeu_si128(out_mm + 0, B0);
363 _mm_storeu_si128(out_mm + 1, B1);
364 _mm_storeu_si128(out_mm + 2, B2);
365 _mm_storeu_si128(out_mm + 3, B3);
366
367 blocks -= 4;
368 in_mm += 4;
369 out_mm += 4;
370 }
371
372 for(size_t i = 0; i != blocks; ++i)
373 {
374 __m128i B = _mm_loadu_si128(in_mm + i);
375
376 B = _mm_xor_si128(B, K0);
377
378 B = _mm_aesenc_si128(B, K1);
379 B = _mm_aesenc_si128(B, K2);
380 B = _mm_aesenc_si128(B, K3);
381 B = _mm_aesenc_si128(B, K4);
382 B = _mm_aesenc_si128(B, K5);
383 B = _mm_aesenc_si128(B, K6);
384 B = _mm_aesenc_si128(B, K7);
385 B = _mm_aesenc_si128(B, K8);
386 B = _mm_aesenc_si128(B, K9);
387 B = _mm_aesenc_si128(B, K10);
388 B = _mm_aesenc_si128(B, K11);
389 B = _mm_aesenclast_si128(B, K12);
390
391 _mm_storeu_si128(out_mm + i, B);
392 }
393 }
AES_ENC_4_ROUNDS
#define AES_ENC_4_ROUNDS(K)
Definition: aes_ni.cpp:67
AES_ENC_4_LAST_ROUNDS
#define AES_ENC_4_LAST_ROUNDS(K)
Definition: aes_ni.cpp:76

## ◆ key_spec()

Key_Length_Specification Botan::Block_Cipher_Fixed_Params< BS, KMIN, 0 , 1 >::key_spec | ( |  | ) | const
| inline virtual inherited

Returns
  object describing limits on key size

Implements Botan::SymmetricAlgorithm.

Definition at line 110 of file block_cipher.h.

111 {
112 return Key_Length_Specification(KMIN, KMAX, KMOD);
113 }

## ◆ maximum_keylength()

size_t Botan::SymmetricAlgorithm::maximum_keylength | ( |  | ) | const
| inline inherited

Returns
  minimum allowed key length

Definition at line 33 of file sym_algo.h.

34 {
35 return key_spec().maximum_keylength();
36 }
Botan::Key_Length_Specification::maximum_keylength
size_t maximum_keylength() const
Definition: key_spec.h:69
Botan::SymmetricAlgorithm::key_spec
virtual Key_Length_Specification key_spec() const =0

## ◆ minimum_keylength()

size_t Botan::SymmetricAlgorithm::minimum_keylength | ( |  | ) | const
| inline inherited

Returns
  maxmium allowed key length

Definition at line 41 of file sym_algo.h.

42 {
43 return key_spec().minimum_keylength();
44 }
Botan::SymmetricAlgorithm::key_spec
virtual Key_Length_Specification key_spec() const =0
Botan::Key_Length_Specification::minimum_keylength
size_t minimum_keylength() const
Definition: key_spec.h:61

## ◆ name()

std::string Botan::AES_192_NI::name | ( |  | ) | const
| inline virtual

Returns
  name of this algorithm

Implements Botan::Algorithm.

Definition at line 49 of file aes_ni.h.

49 { return "AES-192"; }

## ◆ parallel_bytes()

size_t Botan::BlockCipher::parallel_bytes | ( |  | ) | const
| inline inherited

Returns
  prefererred parallelism of this cipher in bytes

Definition at line 35 of file block_cipher.h.

36 {
37 return parallelism() * block_size() * BOTAN_BLOCK_CIPHER_PAR_MULT;
38 }
Botan::BlockCipher::parallelism
virtual size_t parallelism() const
Definition: block_cipher.h:30
Botan::BlockCipher::block_size
virtual size_t block_size() const =0

## ◆ parallelism()

size_t Botan::AES_192_NI::parallelism | ( |  | ) | const
| inline virtual

Returns
  native parallelism of this cipher in blocks

Reimplemented from Botan::BlockCipher.

Definition at line 43 of file aes_ni.h.

43 { return 4; }

## ◆ set_key() [1/2]

void Botan::SymmetricAlgorithm::set_key | ( | const SymmetricKey & | key | ) |
| inline inherited

Set the symmetric key of this object.

Parameters

  key | the SymmetricKey to be set.

Definition at line 60 of file sym_algo.h.

References Botan::OctetString::begin(), and Botan::OctetString::length().

Referenced by Botan::aont_unpackage(), Botan::Lion::decrypt_n(), Botan::PKCS5_PBKDF2::derive_key(), Botan::ECB_Decryption::ECB_Decryption(), Botan::ECB_Encryption::ECB_Encryption(), Botan::Lion::encrypt_n(), Botan::HMAC_RNG::HMAC_RNG(), Botan::MAC_Filter::MAC_Filter(), Botan::HMAC_RNG::reseed(), Botan::XTS_Encryption::set_key(), Botan::EAX_Base::set_key(), Botan::XTS_Decryption::set_key(), Botan::Record_Writer::set_keys(), Botan::Record_Reader::set_keys(), and Botan::StreamCipher_Filter::StreamCipher_Filter().

61 { set_key(key.begin(), key.length()); }
Botan::SymmetricAlgorithm::set_key
void set_key(const SymmetricKey &key)
Definition: sym_algo.h:60

## ◆ set_key() [2/2]

void Botan::SymmetricAlgorithm::set_key | ( | const byte | key[],
|  | size_t | length
| ) |  |
| inline inherited

Set the symmetric key of this object.

Parameters

  key | the to be set as a byte array.
  length | in bytes of key param

Definition at line 68 of file sym_algo.h.

69 {
70 if(!valid_keylength(length))
71 throw Invalid_Key_Length(name(), length);
72 key_schedule(key, length);
73 }
Botan::SymmetricAlgorithm::valid_keylength
bool valid_keylength(size_t length) const
Definition: sym_algo.h:51
Botan::Algorithm::name
virtual std::string name() const =0

## ◆ valid_keylength()

bool Botan::SymmetricAlgorithm::valid_keylength | ( | size_t | length | ) | const
| inline inherited

Check whether a given key length is valid for this algorithm.

Parameters

  length | the key length to be checked.

Returns
  true if the key length is valid.

Definition at line 51 of file sym_algo.h.

Referenced by Botan::aont_unpackage(), Botan::HMAC_RNG::HMAC_RNG(), and Botan::Lion::Lion().

52 {
53 return key_spec().valid_keylength(length);
54 }
Botan::Key_Length_Specification::valid_keylength
bool valid_keylength(size_t length) const
Definition: key_spec.h:51
Botan::SymmetricAlgorithm::key_spec
virtual Key_Length_Specification key_spec() const =0

The documentation for this class was generated from the following files:

- src/block/aes_ni/aes_ni.h
- src/block/aes_ni/aes_ni.cpp